#########  #########    #####    ##    #######
#      ##  #      ##   #     #   ##   #
#     # #  #     # #  #       #   #  #
#    #  #  #    #  #  #       #       # 
#   #   #  #   #   #         #         #####
#  #    #  #  #    #       #                #
# #     #  # #     #     #                   #
##      #  ##      #   #                    #
#########  #########  #########      #######


#########  #########  #       #  ########   #########  #########    #######
       #   #       #  ##     ##  #       #      #      #           #
      #    #       #  # #   # #  #       #      #      #          #
     #     #       #  #  # #  #  #      #       #      #           # 
    #      #       #  #   #   #  #######        #      #########    #####
   #       #       #  #       #  #      #       #      #                 #
  #        #       #  #       #  #       #      #      #                  #
 #         #       #  #       #  #       #      #      #                 #
#########  #########  #       #  ########   #########  #########  #######

#engine + application by nil
#script by 002

from VirtualMemory import *
from Debug import *
import math
import random

WINDOW_TITLE = "002's Zombies version 2"
DESCRIPTION = 'This is a CSS memory hack. Red is Survivors and Blue is Zombies. It is recommeded that you have more than 3 people and that you use a gametype with teams. Please mod out the vehicles or use a gametype that does not have them. How to play Zombies: In the beginning of the game, a random player from red is killed. When a player from red dies, they become a zombie. Version 2 now includes "Last Man". The player or players with the highest kill count during this game becomes "Last Man" after all players have become zombies.'
EXECUTION_TIME_INTERVAL = 0.5

#Halo Demo constants
FIRST_STATIC_PLAYER_ADDRESS = 0x4BD7AFD0
STATIC_PLAYER_SIZE = 0x200
TEAM_INDEX_OFFSET = 0x1E
RESPAWN_TIME_OFFSET = 0x2A
ARMOR_COLOR_OFFSET = 0x5C
PLAYER_OBJECT_ID_OFFSET = 0x32
INVALID_PLAYER_OBJECT_ID = 0xFFFF

FIRST_TABLE_OBJECT_ADDRESS = 0x4BB206EC
OBJECT_TABLE_SIZE = 12
OFFSET_TO_HALO_OBJECT_POINTER = 0x8

OFFSET_OF_KILLS = 0x4BD7B068
STATS_ARRAY_SIZE = 0x200

OFFSET_TO_PLAYER_Z_COORDINATE = 0x64

MAX_HALO_PLAYERS = 16
READ_TEAM_INDEX = 0
BLUE_TEAM_INDEX = 1

def execute(timeElapsed):
	playerZedCheck = 0
	playerCheck = 0
	global timmy
	global gameOn
	global allowSwitch
	global lastManHasHappened
	global scoreList
	global gameOver
	if timeElapsed == 0:
		gameOver = 0
		lastManHasHappened = 0
		gameOn = 0
		scoreList = [-999]
		allowSwitch = 0
		timmy = 7
		writeToLog("The zombie game shall start. All players will now join the red (survivor) team.")
		lastMen = 0
		#setting up game...
		for playerIndex in range(0, MAX_HALO_PLAYERS):
			#changing team
			writeUInt16(FIRST_STATIC_PLAYER_ADDRESS + TEAM_INDEX_OFFSET + STATIC_PLAYER_SIZE * playerIndex,0)
			#changing color
			writeUInt16(FIRST_STATIC_PLAYER_ADDRESS + ARMOR_COLOR_OFFSET + STATIC_PLAYER_SIZE * playerIndex,2)
			#getting id of player
			playerObjectID = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + PLAYER_OBJECT_ID_OFFSET + STATIC_PLAYER_SIZE * playerIndex)
			#getting object address
			playerAddress = readUInt32(FIRST_TABLE_OBJECT_ADDRESS + OBJECT_TABLE_SIZE * playerObjectID + OFFSET_TO_HALO_OBJECT_POINTER)
			#killing person
			writeFloat(playerAddress + OFFSET_TO_PLAYER_Z_COORDINATE,-50)
	if timeElapsed == 7:
		#Let's randomly pick someone to die. We need to somehow count all of the lving players.
		livingPlayerCounter = 0
		writeToLog("All players have joined red.")
		for playerIndex in range (0, MAX_HALO_PLAYERS):
			playerObjectID = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + PLAYER_OBJECT_ID_OFFSET + STATIC_PLAYER_SIZE * playerIndex)
			if playerObjectID != 0 and playerObjectID != INVALID_PLAYER_OBJECT_ID:
				livingPlayerCounter = livingPlayerCounter + 1
		#A player has been picked. Their team will be switched to blue.
		killingThisPlayer = random.randint(0,livingPlayerCounter - 1)
		if livingPlayerCounter == 1:
			writeToLog("There is 1 player detected. This might be a boring game.")
		if livingPlayerCounter != 1:
			writeToLog("There are " + str(livingPlayerCounter) + " players detected.")
		while (gameOn == 0):
			playerIndex = random.randint(0,MAX_HALO_PLAYERS)
			killingThisPlayer = random.randint(0,livingPlayerCounter - 1)
			#Getting object id to kill...
			playerObjectID = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + PLAYER_OBJECT_ID_OFFSET + STATIC_PLAYER_SIZE * killingThisPlayer)
			if playerObjectID != 0 and playerObjectID != INVALID_PLAYER_OBJECT_ID:
				#Found it. Now to get the object's address.
				playerAddress = readUInt32(FIRST_TABLE_OBJECT_ADDRESS + OBJECT_TABLE_SIZE * playerObjectID + OFFSET_TO_HALO_OBJECT_POINTER)
				#okay, now to set the object's z to negative fifty to kill the player.
				writeFloat(playerAddress + OFFSET_TO_PLAYER_Z_COORDINATE,-50)
				#now let's write this.
				writeToLog(readUTF16String(FIRST_STATIC_PLAYER_ADDRESS + STATIC_PLAYER_SIZE * killingThisPlayer) + " has been randomly picked to die.")
				gameOn = 1
	for playerIndex in range(0, MAX_HALO_PLAYERS):
		#getting object ID of every player...
		playerObjectID = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + PLAYER_OBJECT_ID_OFFSET + STATIC_PLAYER_SIZE * playerIndex)
		#getting team index of every player...
		teamindex = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + TEAM_INDEX_OFFSET + STATIC_PLAYER_SIZE * playerIndex)
		#checking for dead red players or team switchers. The amnesty period must also pass. All blue players are exempt from this unless they attempted to switch to red.
		if allowSwitch == 1 and playerObjectID == INVALID_PLAYER_OBJECT_ID and teamindex != 1:
			#A red player has been killed.
			playerAddress = readUInt32(FIRST_TABLE_OBJECT_ADDRESS + OBJECT_TABLE_SIZE * playerObjectID + OFFSET_TO_HALO_OBJECT_POINTER)
			#for recording purposes, this death will be recorded
			if readUTF16String(FIRST_STATIC_PLAYER_ADDRESS + STATIC_PLAYER_SIZE * playerIndex) != "":
				writeToLog(readUTF16String(FIRST_STATIC_PLAYER_ADDRESS + STATIC_PLAYER_SIZE * playerIndex) + " has died and joined the zombie horde.")
			#changing team...
			writeUInt16(FIRST_STATIC_PLAYER_ADDRESS + TEAM_INDEX_OFFSET + STATIC_PLAYER_SIZE * playerIndex, BLUE_TEAM_INDEX)
			#changing color
			writeUInt16(FIRST_STATIC_PLAYER_ADDRESS + ARMOR_COLOR_OFFSET + STATIC_PLAYER_SIZE * playerIndex,3)
		if playerObjectID == 0 or playerObjectID == INVALID_PLAYER_OBJECT_ID:
			writeUInt16(FIRST_STATIC_PLAYER_ADDRESS + RESPAWN_TIME_OFFSET + STATIC_PLAYER_SIZE * playerIndex, 0)
			
	for playerIndex in range(0, MAX_HALO_PLAYERS):
		#checking if all players are dead or on blue team
		playerObjectID = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + PLAYER_OBJECT_ID_OFFSET + STATIC_PLAYER_SIZE * playerIndex)
		#getting team index of every player...
		teamindex = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + TEAM_INDEX_OFFSET + STATIC_PLAYER_SIZE * playerIndex)
		playerCheck = playerCheck + 1
		if playerObjectID == 0 or playerObjectID == INVALID_PLAYER_OBJECT_ID or teamindex == 1:
			if timeElapsed > 7:
				playerZedCheck = playerZedCheck + 1
	if playerZedCheck == playerCheck and gameOver == 0 and lastManHasHappened == 0:
		writeToLog("All players are zombies. The player or players with the most kills will be last man.")
		gameOver = 1
		lastMen = 0
		timmy = timeElapsed + 3
	if gameOver == 1 and timeElapsed == timmy and lastManHasHappened == 0:
		for playerIndex in range(0, MAX_HALO_PLAYERS):
			playerObjectID = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + PLAYER_OBJECT_ID_OFFSET + STATIC_PLAYER_SIZE * playerIndex)
			if playerObjectID != 0 and playerObjectID != INVALID_PLAYER_OBJECT_ID:
				addThis = readUInt16(OFFSET_OF_KILLS + STATS_ARRAY_SIZE * playerIndex)
				scoreList.append(addThis)
		for playerIndex in range(0, MAX_HALO_PLAYERS):
			playerObjectID = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + PLAYER_OBJECT_ID_OFFSET + STATIC_PLAYER_SIZE * playerIndex)
			currentScore = readUInt16(OFFSET_OF_KILLS + STATS_ARRAY_SIZE * playerIndex)
			lastManHasHappened = 1
			if currentScore == max(scoreList) and playerObjectID != 0 and playerObjectID != INVALID_PLAYER_OBJECT_ID:
				writeToLog(readUTF16String(FIRST_STATIC_PLAYER_ADDRESS + STATIC_PLAYER_SIZE * playerIndex) + " has been picked to be Last Man with a kill count of " + str(max(scoreList)) + "!")
				#changing team
				writeUInt16(FIRST_STATIC_PLAYER_ADDRESS + TEAM_INDEX_OFFSET + STATIC_PLAYER_SIZE * playerIndex,0)
				#changing color
				writeUInt16(FIRST_STATIC_PLAYER_ADDRESS + ARMOR_COLOR_OFFSET + STATIC_PLAYER_SIZE * playerIndex,2)
				#getting id of player
				playerObjectID = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + PLAYER_OBJECT_ID_OFFSET + STATIC_PLAYER_SIZE * playerIndex)
				#getting object address
				playerAddress = readUInt32(FIRST_TABLE_OBJECT_ADDRESS + OBJECT_TABLE_SIZE * playerObjectID + OFFSET_TO_HALO_OBJECT_POINTER)
				#killing person
				writeFloat(playerAddress + OFFSET_TO_PLAYER_Z_COORDINATE,-50)
				allowSwitch = 0
				timmy = timeElapsed + 5
	if timeElapsed == timmy:
		allowSwitch = 1
def finish(timeElapsed, forcedShutDown):
	if (timeElapsed - 7) < 0:
		writeToLog("The Zombies game has ended too early.")
	if (timeElapsed - 7) >= 0:
		writeToLog("The Zombies game has ended. This game took " + str(timeElapsed - 7) + " seconds...")